/*!
 * KoliBri - The accessible HTML-Standard
 */
import{o as oe,s as se,j,G}from"./prop.validators.js";export{K as KoliBriDevHelper}from"./prop.validators.js";import{setMode}from"@stencil/core/internal/client";export{getAssetPath,setAssetPath,setNonce,setPlatformOptions}from"@stencil/core/internal/client";import{L as Log}from"./dev.utils.js";import{p as processEnv}from"./reuse.js";export{s as setCurrentLocation}from"./ariaCurrentService.js";import{s as setCustomTagNames,K as KolToastContainerTag}from"./component-names.js";import{i as initializeI18n}from"./i18n.js";export{c as BUNDESAEMTER,e as BUNDESANSTALTEN,a as BUNDESMINISTERIEN,f as BUND_LOGO_TEXT_MAP,b as Bundesamt,d as Bundesanstalt,B as Bundesministerium}from"./bund.js";var KeyEnum,TagEnum;!function(t){t[t.error=0]="error",t[t.warning=1]="warning",t[t.info=2]="info",t[t.success=3]="success",t[t.message=4]="message",t[t.close=5]="close",t[t["form-description"]=6]="form-description",t[t.of=7]="of",t[t.characters=8]="characters",t[t.new=9]="new",t[t["no-entries"]=10]="no-entries",t[t["change-order"]=11]="change-order",t[t["action-running"]=12]="action-running",t[t["action-done"]=13]="action-done",t[t["page-first"]=14]="page-first",t[t["page-back"]=15]="page-back",t[t["page-next"]=16]="page-next",t[t["page-last"]=17]="page-last",t[t["entries-per-site"]=18]="entries-per-site",t[t["page-current"]=19]="page-current",t[t["page-selected"]=20]="page-selected",t[t["page-per-site"]=21]="page-per-site",t[t["logo-description"]=22]="logo-description",t[t["open-link-in-tab"]=23]="open-link-in-tab",t[t["kolibri-logo"]=24]="kolibri-logo"}(KeyEnum||(KeyEnum={})),function(t){t[t.abbr=0]="abbr",t[t.accordion=1]="accordion",t[t["accordion-group"]=2]="accordion-group",t[t.alert=3]="alert",t[t.avatar=4]="avatar",t[t.badge=5]="badge",t[t.breadcrumb=6]="breadcrumb",t[t.button=7]="button",t[t["button-group"]=8]="button-group",t[t["button-link"]=9]="button-link",t[t.card=10]="card",t[t.combobox=11]="combobox",t[t.details=12]="details",t[t.form=13]="form",t[t.heading=14]="heading",t[t.icon=15]="icon",t[t.image=16]="image",t[t["indented-text"]=17]="indented-text",t[t["input-checkbox"]=18]="input-checkbox",t[t["input-color"]=19]="input-color",t[t["input-date"]=20]="input-date",t[t["input-email"]=21]="input-email",t[t["input-file"]=22]="input-file",t[t["input-number"]=23]="input-number",t[t["input-password"]=24]="input-password",t[t["input-radio"]=25]="input-radio",t[t["input-range"]=26]="input-range",t[t["input-text"]=27]="input-text",t[t.kolibri=28]="kolibri",t[t.link=29]="link",t[t["link-button"]=30]="link-button",t[t["link-group"]=31]="link-group",t[t.logo=32]="logo",t[t.modal=33]="modal",t[t.nav=34]="nav",t[t.pagination=35]="pagination",t[t.progress=36]="progress",t[t.select=37]="select",t[t.separator=38]="separator",t[t["skip-nav"]=39]="skip-nav",t[t.spin=40]="spin",t[t["split-button"]=41]="split-button",t[t.symbol=42]="symbol",t[t.table=43]="table",t[t["table-stateless"]=44]="table-stateless",t[t["table-stateful"]=45]="table-stateful",t[t.tabs=46]="tabs",t[t.textarea=47]="textarea",t[t["toast-container"]=48]="toast-container",t[t.toolbar=49]="toolbar",t[t.tooltip=50]="tooltip",t[t.tree=51]="tree",t[t["tree-item"]=52]="tree-item"}(TagEnum||(TagEnum={}));const KoliBri=new oe("kol",KeyEnum,TagEnum);setMode((t=>{try{t.shadowRoot instanceof ShadowRoot&&se(t,j(t))}catch(t){}return"default"})),import("./devtools.js").then((t=>{"object"==typeof t&&null!==t&&"function"==typeof t.initialize&&t.initialize()})).catch((t=>{Log.error(t)})),"development"===processEnv&&import("./index2.js");const globalFn=()=>{},appGlobalScript=globalFn,globalScripts=appGlobalScript;let initialized=!1;const bootstrap=async(t,e,o)=>{var n,i;initializeI18n(null!==(i=null===(n=null==o?void 0:o.translation)||void 0===n?void 0:n.name)&&void 0!==i?i:"de",null==o?void 0:o.translations),(null==o?void 0:o.transformTagName)&&setCustomTagNames(null==o?void 0:o.transformTagName);const a=await G(t,e,o);return initialized=!0,a},register=bootstrap,isInitialized=()=>initialized;class ToasterService{constructor(t,e){this.document=t,this.options=e,this.toastContainerElement=this.document.createElement(KolToastContainerTag),this.document.body.prepend(this.toastContainerElement)}static getInstance(t,e){if(!isInitialized())throw new Error("Toaster: Call KoliBri bootstrap/register method first.");let o=this.instances.get(t);return o||(o=new ToasterService(t,e),this.instances.set(t,o)),o}dispose(){const t=this.toastContainerElement;t?(this.toastContainerElement=void 0,t.remove()):console.warn("Toaster service is already disposed.")}enqueue(t){var e,o;if(this.toastContainerElement&&"function"==typeof this.toastContainerElement.enqueue)return!t.alertVariant&&(null===(e=this.options)||void 0===e?void 0:e.defaultAlertVariant)&&(t.alertVariant=null===(o=this.options)||void 0===o?void 0:o.defaultAlertVariant),this.toastContainerElement.enqueue(t)}closeAll(t=!1){this.toastContainerElement&&"function"==typeof this.toastContainerElement.closeAll&&this.toastContainerElement.closeAll(t)}}ToasterService.instances=new Map,globalScripts();export{KoliBri,ToasterService,bootstrap,register};